/*******************************************************************************
 * FoxWeaponAttachment_ShotgunBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxWeaponAttachment_ShotgunBase extends FoxWeaponAttachment_SemiAutomaticBase
    config(Weapon)
    notplaceable
    hidecategories(Navigation);

simulated function Rotator AddSpread(Rotator BaseAim, const float Spread)
{
    local Vector X, Y, Z;
    local float RandY, RandZ;

    GetAxes(BaseAim, X, Y, Z);
    RandY = FRand() - 0.50;
    RandZ = Sqrt(0.50 - Square(RandY)) * (FRand() - 0.50);
    return rotator((X + ((RandY * Spread) * Y)) + ((RandZ * Spread) * Z));
    //return ReturnValue;    
}

simulated function ImpactInfo CalcWeaponFire(Vector StartTrace, Vector EndTrace, optional out array<ImpactInfo> ImpactList, optional Vector Extent)
{
    local Vector HitLocation, HitNormal;
    local Actor HitActor;
    local TraceHitInfo HitInfo;
    local ImpactInfo CurrentImpact;

    HitActor = Instigator.Trace(HitLocation, HitNormal, EndTrace, StartTrace, true, Extent, HitInfo, 1);
    // End:0x7F
    if(HitActor == none)
    {
        HitLocation = EndTrace;
    }
    CurrentImpact.HitActor = HitActor;
    CurrentImpact.HitLocation = HitLocation;
    CurrentImpact.HitNormal = HitNormal;
    CurrentImpact.RayDir = Normal(EndTrace - StartTrace);
    CurrentImpact.StartTrace = StartTrace;
    CurrentImpact.HitInfo = HitInfo;
    ImpactList[ImpactList.Length] = CurrentImpact;
    return CurrentImpact;
    //return ReturnValue;    
}

simulated function PlayImpactEffects(Vector HitLocation, optional bool bCheckNearMiss)
{
    local int I;
    local Vector StartTrace, EndTrace;
    local array<ImpactInfo> ImpactList;
    local ImpactInfo RealImpact;
    local class<FoxWeapon_ShotgunBase> ShotgunClass;

    bCheckNearMiss = true;
    // End:0x30
    if(WorldInfo.NetMode == NM_DedicatedServer)
    {
        return;
    }
    // End:0x6F
    if(Instigator.FiringMode != 0)
    {
        super(FoxWeaponAttachment).PlayImpactEffects(HitLocation, false);
        return;
    }
    StartTrace = GetMuzzleLoc();
    // End:0xB3
    if(bDebug)
    {
        DrawDebugLine(StartTrace, HitLocation, 255, 255, 255, true);
    }
    ShotgunClass = class<FoxWeapon_ShotgunBase>(WeaponClass);
    // End:0x152
    if((ShotgunClass == none) || WorldInfo.GRI.bClientSideHitDetection && Instigator.IsLocallyControlled())
    {
        super(FoxWeaponAttachment).PlayImpactEffects(HitLocation, false);
    }
    // End:0x2BB
    else
    {
        I = 0;
        J0x15D:
        // End:0x2BB [Loop If]
        if(I < ShotgunClass.default.FragmentsPerShell)
        {
            EndTrace = StartTrace + (vector(AddSpread(rotator(HitLocation - StartTrace), ShotgunClass.default.FragmentSpread)) * ShotgunClass.default.MaxRange);
            RealImpact = CalcWeaponFire(StartTrace, EndTrace, ImpactList);
            // End:0x271
            if(bDebug)
            {
                DrawDebugLine(StartTrace, RealImpact.HitLocation, 0, 255, 0, true);
            }
            super(FoxWeaponAttachment).PlayImpactEffects(RealImpact.HitLocation, bCheckNearMiss);
            bCheckNearMiss = false;
            ++ I;
            // [Loop Continue]
            goto J0x15D;
        }
    }
    //return;    
}

defaultproperties
{
    begin object name=AttachmentMesh class=SkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: SkeletalMeshComponent'Default__FoxWeaponAttachment_ShotgunBase.AttachmentMesh'
    Mesh=AttachmentMesh
    AimOffsetProfileName=Shotgun
    WeaponType=EWeaponType.WT_Secondary
    MuzzleFlashLight=PointLightComponent'Default__FoxWeaponAttachment_ShotgunBase.LightComponent0'
    begin object name=LensComp class=LensFlareComponent
        NextTraceTime=-0.58189640
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxWeaponAttachment_ShotgunBase.LensComp'
    MuzzleLensFlare=LensComp
    begin object name=AttachmentMesh class=SkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: SkeletalMeshComponent'Default__FoxWeaponAttachment_ShotgunBase.AttachmentMesh'
    Components(0)=AttachmentMesh
}